
Redmine - Defect #9377

<br /> is not inserted before macro in Wiki

2011-10-05 19:24 - Masamitsu Murase

Status: New Start date: 2011-10-05

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 1.2.1

Description

<br /> tag is not inserted before macros in Wiki.

For example,

abc

!{{hello_world}}

should be converted to

<p>abc<br />Hello world! Object: Journal, Called with no argument.</p>

 However, it is converted to

<p>abc

Hello world! Object: Journal, Called with no argument.</p>

 Detail and cause:

<br /> in Wiki is inserted by hard_break method in "lib/redmine/wiki_formatting/textile/formatter.rb".

This method replaces "\n" with "<br />" as follows:

          text.gsub!( /(.)\n(?!\n|\Z| *([#*=]+(\s|$)|[{|]))/, "\\1<br />" ) if hard_breaks

 It seems that "[{|]" prevents insertion of "<br />" before CSS style and in table, because CSS style in Wiki starts with "{" and cells of

table are separated by "|".

Macros in Wiki also start with double "{"s, so "<br />" is not inserted before macros.

I think that hard_break method should be

          text.gsub!( /(.)\n(?!\n|\Z| *([#*=]+(\s|$)|\{[^{]|\|))/, "\\1<br />" ) if hard_breaks

to replace "\n" before macros.   Environment:

Redmine version 1.2.1

Ruby version 1.8.7 (patch 174)

Rails version 2.3.5

History

#1 - 2011-10-05 19:34 - Masamitsu Murase

I sent pull request in GitHub.

Please refer to https://github.com/edavis10/redmine/pull/44.

#2 - 2011-10-05 19:49 - Mischa The Evil

- Category set to Text formatting

#3 - 2011-10-05 23:58 - Etienne Massip
https://github.com/edavis10/redmine/pull/44


Please post the patch here.

#4 - 2011-10-06 18:47 - Masamitsu Murase

- File wiki_br_insertion_patch.diff added

I post the patch.

I have already sent a pull request in GitHub.

If it confuses Redmine's contributors, please let me know about what to do.

#5 - 2011-10-06 18:55 - Etienne Massip

Masamitsu Murase wrote:

If it confuses Redmine's contributors, please let me know about what to do.

 It does, because GitHub repo is not an official one (check Contribute) and can potentially differ from the original source.

I think that Eric keep it up to date, though, but this may be not true.

#6 - 2011-10-06 19:01 - Masamitsu Murase

Thank you for your reply, Etienne Massip.

I close the pull request in GitHub to avoid confusion.

Files

wiki_br_insertion_patch.diff 808 Bytes 2011-10-06 Masamitsu Murase
